#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
#
# Tests for DocViewer

from nose.tools import assert_true, assert_equal

from desktop.lib.django_test_util import make_logged_in_client

def test_user_manager():
  c = make_logged_in_client(username="test", is_superuser=True)

  # Test default output
  response = c.get('/docviewer/')
  assert_true("<h1>Welcome to Cloudera Desktop!</h1>" in response.content)

  # Test default to index.md
  response = c.get("/docviewer/userman/")
  response2 = c.get("/docviewer/userman/index.md")
  assert_equal(response.content, response2.content)

  # Test index at the bottom
  assert_true('href="/docviewer/desktop' in response.content)
