#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from desktop.lib.view_util import big_filesizeformat

def format_size_bytes(bytes):
  return big_filesizeformat(bytes)

def format_size_mb(bytes):
  return big_filesizeformat(bytes * 1024 * 1024)

def format_percent_fraction(fraction):
  """
  @param fraction: a number between 0 and 1
  """
  return "%.2f%%" % (fraction * 100)

def format_millis_ago(millis):
  return "%.1fs ago" % (float(millis)/1000)

def format_millis(millis):
  if millis > 10000:
    return "%.1fs" % (float(millis/1000))
  return "%dms" % int(millis)
