# Copyright (c) 2010, Cloudera, inc. All rights reserved.
import unittest

import query

class TestDjangoUtil(unittest.TestCase):
  def test_group(self):
    data = [ dict(a=1, b=2), dict(a=None, b=2), dict(a=1, b=3), dict(a=2, b="foo") ]
    grouped = query.group(data, lambda x: x["a"])

    self.assertEquals(2, len(grouped[1]))
    self.assertEquals(1, len(grouped[2]))
    self.assertEquals(dict(a=2, b="foo"), grouped[2][0])

  def test_query(self):
    class Row(object):
      def __init__(self, a, b):
        self.a, self.b, = a, b 

    data = [ Row("alpha", 1), Row("alpha", 2), Row("beta", 3), Row("beta", 4) ]
    self.assertEquals({"alpha": 3, "beta": 7},
      dict(query.query(data=data, 
                  select=lambda grouping, values: (grouping, sum([ v.b for v in values ])),
                  groupby=lambda row: row.a)))

if __name__ == '__main__':
  unittest.main()