#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
"""Statistics utility functions"""

def quantile(l, p):
    """Return p quantile of list l.

    e.g. p=0.25 for first quartile

    See:
    http://rweb.stat.umn.edu/R/library/base/html/quantile.html
    """
    l_sort = sorted(list(l))
    n = len(l)
    r = 1 + ((n - 1) * p)
    i = int(r)
    f = r - i
    if i < n:
        result =  (1-f)*l_sort[i-1] + f*l_sort[i]
    else:
        result = l_sort[i-1]
    return result

def iqr(l):
  """Return interquartile range of l"""
  q1 = quantile(l, 0.25)
  q3 = quantile(l, 0.75)
  return q3 - q1

