<%namespace name="comps" file="health_components.mako" />
<%namespace name="hm" file="heatmap.mako" />
<%!

from desktop.lib.django_util import make_absolute

%>
<div class="toolbar">
	<img src="/health/static/art/dashboard-logo.png" class="health_logo draggable"/>
</div>
<div id="dashboard_lints" class="view no_overflow jframe_padded">
  <div class="health_lints_wrapper ccs-code">
    <div>
      <div class="health_lints">

        % if lints_by_level['CRITICAL']:
          <div class="box critical">
            <h3>Critical Alerts</h3>
            ${ lints_table(lints_by_level['CRITICAL']) }
          </div>
        % endif

        % if lints_by_level['WARN']:
          <div class="box critical">
            <h3>Warnings</h3>
            ${ lints_table(lints_by_level['WARN']) }
          </div>
        % endif
      </div>
      <div class="health_lints_scroller">
        <div></div>
      </div>
    </div>
  </div>
  <a href="/health/dashboard" class="health_lints_return">&laquo;return</a>
</div>

<%def name="lints_table(lints)">
<table class="lints"> 
%   for lint in lints:
<tr>
  <td class="lint_state">${ comps.state(lint.status) }</td>
  <td>
    <div class="lint_subject">${ comps.subject(lint.subject, target="Health") }</div>
    <div class="lint_name">${lint.name} ${lint.status} <a class="toggle_details collapser"></a></div>
    <div class="lint_details collapsible">
      <div class="lint_message">${lint.message}</div>
      <div class="lint_detail">${lint.detail}</div>
    </div>
  </td>
</tr>
%  endfor
</table>
</%def>
