<%namespace name="comps" file="health_components.mako" />
<%namespace name="hm" file="heatmap.mako" />
<%!

from desktop.lib.django_util import make_absolute

%>

<%comps:head>
	<meta http-equiv="refresh" content="30" />
</%comps:head>

<div class="toolbar">
	<img src="/health/static/art/dashboard-logo.png" class="health_logo draggable"/>
</div>
<div id="health_dashboard" class="view no_overflow jframe_padded">
	<div class="ccs-code">
		<a class="health_launch_browser" target="Health" href="/health/">browse health details</a>
		% if lints_by_level['CRITICAL'] or lints_by_level['WARN']:
			<a class="health_launch_lints" href="/health/dashboard/lints">
				${len(lints_by_level['CRITICAL']) + len(lints_by_level['WARN'])} lint warnings&raquo;
			</a>
		% endif
		<div class="health_heatmap_wrapper">
			<div>
				<div class="health_heatmap">
					${ hm.heatmap(report, 'Health') }
				</div>
				<div class="health_heatmap_scroller">
					<div></div>
				</div>
			</div>
			<div class="health_heatmap_tips">
				<div class="health_heatmap_machine"></div>
				<div class="health_heatmap_tip"></div>
			</div>
		</div>
		<ul class="health_footer clearfix">
			<li class="health_footer_section">
						<ul class="health_filters ccs-no_select">
							<li>filter nodes:</li>
							<li>
								<a class="health_chex health_checked">healthy</a>
							</li>
							<li>
								<a class="health_chex health_checked">troubled</a>
							</li>
							<li>
								<a class="health_chex health_checked">critical</a>
							</li>
							<li>by role:
								<ul class="health_filter_by_role">
									<li>
										<a class="health_chex health_checked">nn</a>
									</li>
									<li>
										<a class="health_chex health_checked">snn</a>
									</li>
									<li>
										<a class="health_chex health_checked">jt</a>
									</li>
									<li>
										<a class="health_chex health_checked">tt</a>
									</li>
									<li>
										<a class="health_chex health_checked">dn</a>
									</li>
								</ul>
							</li>
						</ul>
			</li>
			<li class="health_footer_section">
						<table class="health_cluster_summary">
							<thead>
								<tr>
									<th>clusters</th>
									<th>
										<div class="health_dot health_up"></div>
									</th>
									<th>
										<div class="health_dot health_error"></div>
									</th>
									<th>
										<div class="health_dot health_down"></div>
									</th>
								</tr>
							</head>
							<tbody>
							% for cluster in clusters:
								<tr>
									<td>
									<a href="${ url('health.views.cluster', id=cluster['id']) }" target="Health">
										${ cluster['type'] }(${ cluster['name'] })
									</a>
									</td>
									${ comps.statemap(cluster['state_counts']) }
								</tr>
							% endfor
								<tr>
									<td>
									Host Summary
									</td>
										${ comps.statemap(up_down_host_counts) }
								</tr>
							</tbody>
						</table>
				</li>
			</ul>
		</div>
	</div>
</div>