<%!
from health.view_util import IMAGE_MAP, IMAGE_MAP_KEYS
from health.models import Participant
from health.clusters import Cluster
  %>

<%def name="head(title='Cluster Health')">
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
  <title>Cloudera Desktop ${title}</title>
  ${caller.body()}
</head>
<body>
</%def>

<%def name="foot()">
</body>
</html>
</%def>


<%def name="header(title='Cluster Health')">
  <%self:head title='${title}'>
    <link rel="stylesheet" href="/health/static/css/health.css" type="text/css" media="screen" charset="utf-8">
    % if (caller and caller.body):
      ${caller.body()}
    % endif
  </%self:head>
  <div class="health">
</%def>

<%def name="footer()">
  </div>
  ${foot()}
</%def>

<%def name="subject(subject, make_link=True, target='')">
<%doc>
Displays a simple icon and name for a subject, which can be either
a Participant or a Cluster.

@param make_link: if true, will make the name link to that object's health page
</%doc>
% if isinstance(subject, Participant):
%   if make_link:
      <a href="${url('health.views.host', ip=subject.ip)}" class="health_machine health_tip" title="${subject.name}" target="${target}">
%   else:
      <span class="health_machine" title="${subject.name}">
%   endif

    <span class="health_role_abv">${subject.role_abv}</span>
    <span class="health_role">${subject.role_nice}</span>
    <span class="health_name">${subject.name}</span>

%   if make_link:
   </a>
%   else:
   </span>
%   endif
% elif isinstance(subject, Cluster):
%   if make_link:
    <a href="${ url('health.views.cluster', id=subject.id) }" class="health_cluster health_tip" target="${target}">
%   else:
    <span class="health_cluster">
%   endif
      Cluster <i>${subject.name}</i> (${subject.type})
%   if make_link:
    </a>
%   else:
    </span>
%   endif
% else:
    ${ str(subject) }
% endif
</%def>


<%def name="statemap(d)">
<%doc>
  Takes a map with up/error/down counts, and returns 
  the data with icons. Each is wrapped in a td tag.
</%doc>
% for s in IMAGE_MAP_KEYS:
    % if d.get(s, 0) == 0:
      <td class="ok health_${s}">
    % else:
      <td class="health_${s}">
    % endif
        ${str(d.get(s, 0))}  ${state(s)}&nbsp;
      </td>
% endfor
</%def>

<%def name="state(d)">
<%doc>
  Converts up/down/error to icons.
</%doc>
% if d not in IMAGE_MAP:
    N/A
% else:
  <div class="ccs-inline health_state" style="background: url(${IMAGE_MAP[d][0]}) no-repeat;">${d}</div>
% endif
</%def>

<%def name="chart_link(link)">
  <a href="${link}"><img src="/static/art/icons/chart_curve.png" border="0"/></a>
</%def>

<%def name="statuspage(participant)">
<% url = participant.http_proxy_url %>
% if url:
  <a href="${participant.http_proxy_url}"><img src="/static/art/icons/link.png" alt="status page" border="0"/></a>
% endif
</%def>

<%def name="lints_table(lints)">
%   for lint in lints:
  <table class="lints">
    <tr>
      <td>${ state(lint.status) }</td>
      <td class="status">${ subject(lint.subject) }</td>
      <td><b>${lint.name} ${lint.status}</b><br />${lint.message}<br /><span class="lint-detail">${lint.detail}</span></td>
    </tr>
  </table>
%  endfor
</%def>
