<%namespace name="comps" file="health_components.mako" />
<%namespace name="reports" file="reports.mako" />

Lame table representation:
${ reports.table(report) }

Awesome heat map representation:
${ heatmap(report) }



<%def name="heatmap(report, target='')">
<% extractors = [e for e in report.extractors if e.heat_detector] %>
<table class="heat-blocks">
% for participant, cells in sorted(report.cells_by_participant.iteritems(), key=lambda x: x[0].name):
<tr>
  <td class="health_comp">
    ${comps.subject(participant, make_link=True, target=target)}
  </td>
%   for extractor in extractors:
  <td>
<%       cell = cells.get(extractor) %>
%     if cell is not None and report.get_intensity_for_cell(cell) is not None:
        ${ heatblock(map, cells[extractor], participant, target) }
%     else:
        <a class="heat-spot heat-cell-na" title="${participant.short_name} | ${extractor.name} unavailable" href="${url('health.views.host', ip=participant.ip)}" style="display: block" target="${target}"></a>
%     endif
%   endfor
  </td>
</tr>
% endfor
</table>
</%def>

<%def name="heatblock(map, cell, subject, target='')">
<%
  from math import sqrt

  intensity = report.get_intensity_for_cell(cell)
  clamp_intensity = max(min(1, float(intensity)), 0)
  color = "#%02x%02x00" % (int(sqrt(clamp_intensity) * 255),
                           int((sqrt(1 - clamp_intensity)) * 255))
  css = "troubled"
  if color == "#00ff00":
    css = "healthy"
  if color == "#ff0000":
    css = "critical"
  
%>
  <a style="background-color: ${color};" class="heat-spot health_tip ${css}" title="${cell.participant.short_name} | ${cell.extractor.name} ${cell.formatted_value}" href="${url('health.views.host', ip=subject.ip)}" style="display: block" target="${target}"></a>
</%def>
