<%namespace name="comps" file="health_components.mako" />
<%namespace name="hm" file="heatmap.mako" />
<%!

from desktop.lib.django_util import make_absolute

%>
${ comps.header() }
<h1>Cluster Health</h1>


% if lints_by_level['CRITICAL']:
<div class="box critical">
<h3>Critical Alerts</h3>
${ comps.lints_table(lints_by_level['CRITICAL']) }
<div style="clear:both;"></div>
</div>
% endif

<div class="box heatbox">
  <h3>At a glance</h3>
  ${ hm.heatmap(report) }
</div>

<div class="box clusters">
  <h3>Clusters</h3>
  <table>
  % for cluster in clusters:
    <tr>
      <td class="first">
      <a href="${ url('health.views.cluster', id=cluster['id']) }">
        ${ cluster['type'] }(${ cluster['name'] })
      </a>
      </td>

      ${ comps.statemap(cluster['state_counts']) }

    </tr>
  % endfor
    <tr class="bottom">
      <td class="first">
      Host Summary
      </td>

        ${ comps.statemap(up_down_host_counts) }

    </tr>
  </table>

</div>



<div style="clear:both;"></div>

% if lints_by_level['WARN']:
<h3>Warnings</h3>
${ comps.lints_table(lints_by_level['WARN']) }
% endif

</p>


<div class="box host">
<h3>Hosts</h3>
<ul>
% for ip, host in hosts.iteritems():
<li>${ comps.state(host['state']) }<a href="${ url('health.views.host', ip=ip) }">${ip}</a></li>
% endfor
</ul>

</div>
${ comps.footer() }