#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
"""Python code for health-specific view functionality."""

from health.data import DataPoint
from health import lint

# The images in our static directory
# tuples of (src, alt)
ACCEPT = ("/static/art/icons/accept.png", "up")
ERROR = ("/static/art/icons/error.png", "error")
EXCLAMATION = ("/static/art/icons/exclamation.png", "down")

IMAGE_MAP = {
  DataPoint.STATE_UP[1]: ACCEPT,
  DataPoint.STATE_ERROR[1]: ERROR,
  DataPoint.STATE_DOWN[1]: EXCLAMATION,
  lint.OK: ACCEPT,
  lint.WARN: ERROR,
  lint.CRITICAL: EXCLAMATION,
}
# These are kept separately, to maintain the order.
IMAGE_MAP_KEYS = [ 
  DataPoint.STATE_UP[1], 
  DataPoint.STATE_ERROR[1], 
  DataPoint.STATE_DOWN[1] 
]
