#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
#
# Functional test for hello app.
#
# This test uses "nose"-style testing (no need for a TestCase),
# and nose-style assertions.  It uses the Django client to
# go through most of the stack.
#
# You can use nose.tools.set_trace() to set a breakpoint while
# developing the test.

import simplejson
from nose.tools import *

from desktop.lib.django_test_util import make_logged_in_client

def test_require_login():
  c = make_logged_in_client()
  # All apps require login.
  c.login(username="test", password="test")

  # Test basic output.
  response = c.get('/hello/')
  assert_true("Bonjour" in response.content)

  # Or like so.
  assert_equal("Bonjour", c.get('/hello/').context["greeting"])

  # Test JSON too
  response = c.get('/hello/', dict(format="json"))
  assert_equal(dict(greeting="Bonjour"), simplejson.JSONDecoder().decode(response.content))

  # Can also do this:
  assert_equal(dict(greeting="Bonjour"), c.get_json('/hello/', dict(format="json")))

