#!/usr/bin/python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
#
# Template for python Hadoop streaming.  Fill in the map() and reduce() 
# functions, which should call emit(), as appropriate.
#
# Test your script with
#  cat input | python wordcount.py map | sort | python wordcount.py reduce

import sys
import re

def map(line):
  # Fill this in!
  pass

def reduce(key, values):
  # Fill this in
  pass


# Common library code follows:

def emit(key, value):
  """
  Emits a key->value pair.  Key and value should be strings.
  """
  print "\t".join( (key, value) )

def run_map():
  """Calls map() for each input value."""
  for line in sys.stdin:
    line = line.rstrip()
    map(line)

def run_reduce():
  """Gathers reduce() data in memory, and calls reduce()."""
  prev_key = None
  values = []
  for line in sys.stdin:
    line = line.rstrip()
    key, value = re.split("\t", line, 1)
    if prev_key == key:
      values.append(value)
    else:
      if prev_key is not None:
        reduce(prev_key, values)
      prev_key = key
      values = [ value ]

  if prev_key is not None:
    reduce(prev_key, values)

def main():
  """Runs map or reduce code, per arguments."""
  if len(sys.argv) != 2 or sys.argv[1] not in ("map", "reduce"):
    print "Usage: %s <map|reduce>" % sys.argv[0]
    sys.exit(1)
  if sys.argv[1] == "map":
    run_map()
  elif sys.argv[1] == "reduce":
    run_reduce()
  else:
    assert False

if __name__ == "__main__":
  main()
