#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
"""Configuration for the job submission application"""

from desktop.lib.conf import Config
from desktop.lib import paths

JOBSUBD_HOST = Config(
  key="jobsubd_host",
  help="Host where jobsubd thrift daemon is running",
  default="localhost")

JOBSUBD_PORT = Config(
  key="jobsubd_port",
  help="Port where jobsubd thrift daemon is running",
  default=8001,
  type=int)

REMOTE_DATA_DIR = Config(
  key="remote_data_dir",
  default="/user/cloudera/jobsub",
  help="Location on HDFS where the jobsub examples and templates are stored.")

# Where examples and templates are stored.
LOCAL_DATA_DIR = Config(
  key="local_data_dir",
  default=paths.get_desktop_root("apps", "jobsub", "data"),
  help="Location on local FS where examples and template are stored",
  private=True
)

SAMPLE_DATA_DIR = Config(
  key="sample_data_dir",
  default=paths.get_thirdparty_root("sample_data"),
  help="Location on local FS where sample data is stored",
  private=True)

# Location of trace jar
ASPECTPATH = Config(
  key="aspect_path",
  default=paths.get_desktop_root("apps", "jobsub", "java-lib", "trace.jar"),
  help="Path to the built jobsub trace.jar",
  private=True)

# Location of aspectj weaver jar
ASPECTJWEAVER = Config(
  key="aspectj_weaver",
  default=paths.get_thirdparty_root(
    "java", "aspectj-1.6.5", "aspectjweaver.jar"),
  help="Path to aspectjweaver.jar from aspectj distribution",
  private=True)
