// (c) Copyright 2010 Cloudera, Inc.
package com.cloudera.jobsub;

import org.apache.hadoop.mapred.RunningJob;
import java.io.PrintStream;
import java.io.IOException;

/**
 * Records JobIDs into a file specified by $DEFAULT_JOB_LOG.
 */
public class JobClientTracer {
  private static JobClientTracer instance = new JobClientTracer();
  private PrintStream reportStream;

  public static final String DEFAULT_JOB_LOG="reported-jobs.txt";

  public synchronized static JobClientTracer getInstance() {
    return instance;
  }

  private JobClientTracer() {
    try {
      String filename = System.getenv("CLOUDERA_JOBTRACE_LOG");
      if (filename == null) {
        filename = DEFAULT_JOB_LOG;
      }
      reportStream = new PrintStream(filename);
    } catch (IOException ioe) {
      throw new RuntimeException(ioe);
    }
  }

  public void submittedJob(RunningJob job) {
    reportStream.println(job.getJobID());
    reportStream.flush();
  }
}
