#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from jobsubd.ttypes import SubmissionError

class SubmissionErrorRecastMiddleware(object):
  """
  When this middleware sees a SubmissionError,
  it adds a response_data field to it.

  We do this instead of "monkey-patching" a response_data 
  property into SubmissionError.
  """
  def process_exception(self, request, exception):
    if isinstance(exception, SubmissionError) and not hasattr(SubmissionError, "response_data"):
      exception.response_data = dict(code="SUBMISSION_ERROR", message=exception.message)
