#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
"""
Models used by the jobsubd server.
"""
from django.db import models

# TODO(philip): Move into separate django app?
class ServerSubmissionState(models.Model):
  """
  Used by jobsubd (the daemon) to keep information
  about running processes.

  The webapp should not access this directly.
  """
  # Temporary directory where this job is running
  tmp_dir = models.CharField(max_length=128)
  # pid may be useful for debugging.
  pid = models.IntegerField(null=True)
  # This is an enum from jobsubd.thrift:State
  submission_state = models.IntegerField()
  start_time = models.DateTimeField(auto_now_add=True)
  end_time = models.DateTimeField(null=True)
