<%namespace name="comps" file="jobtracker_components.mako" />
<%!
  from jobtracker.views import format_counter_name
  from filebrowser.views import location_to_url, location_to_path
  import os
  import re
%>

<%def name="task_table(tasks)">
  <table class="ccs-data_table sortable" cellpadding="0" cellspacing="0">
    <thead>
      <tr>
        <th>Tasks</th>
        <th colspan="2">Type</th>
      </tr>
    </thead>
    <tbody>
      % for task in tasks:
        <tr>
          <td class="task_table_id">${task.taskId_short}</td>
          <td class="task_table_type">${task.taskType}</td>
          <td class="jtask_view_col"><a class="frame_tip jtask_view jt_slide_right" title="View this task"
                 href="${ url('jobtracker.views.single_task', jobid=job.jobId, taskid=task.taskId) }"></a></td>
        </tr>
      % endfor
    </tbody>
  </table>
</%def>
<%def name="rows_for_conf_vars(rows)">
    %  for k, v in rows.iteritems():
      <tr>
          <td>${format_counter_name(k)}</td>
          <%
            splitArray = v.split(",")
          %>
            <td>
            % for i, val in enumerate(splitArray):
               % if location_to_url(request, val) != None:
                  <%
                    if request.fs.isfile(location_to_path(request,val)):
                      target = "FileViewer"
                    else:
                      target = "FileBrowser"
                  %>
                  <a href="${location_to_url(request, val)}" title="${val}" target="${target}">${os.path.basename(val)}</a>
                  % if i != len(splitArray) - 1:
                    <br>
                  % endif  
               % else: 
                  ${val}
               % endif
            % endfor
            </td>
        </tr>
    % endfor
</%def>

  ${comps.header("Job: " + job.jobId + " :: Job Browser")}
    
    <div id="job_browser_job" class="view jframe_padded">
      <div class="jtv_meta_top clearfix">
        <dl>
          <dt>Job ID</dt>
          <dd>${job.jobId}</dd>
          <dt>User</dt>
          <dd>${job.user}</dd>
        </dl>
        <dl>
          <dt>Status</dt>
          <dd>${job.status.lower()}</dd>
          <dt>Output</dt>
          <dd>
          <%
            output_dir = job.conf_keys.get('mapredOutputDir', "")
            location_url = location_to_url(request, output_dir)
            basename = os.path.basename(output_dir)
          %>
          % if location_url != None:
            <a href="${location_url}" title="${output_dir}" target="FileBrowser">${basename}</a>
          % else:
            ${basename}
          % endif
          <dd>
        </dl>
        % if job.status.lower() == 'running' or job.status.lower() == 'pending':
        <dl>
          <dt>Kill Job:</dt>
          <dd>
          <a href="${url('jobtracker.views.kill_job', jobid=job.jobId)}" class="frame_tip jt_kill confirm_and_post" title="Kill this job">kill</a>
          </dd>
        </dl>
        % endif

      </div>

      <div class="ccs-tab_ui">
        <ul class="ccs-tabs jtv_tabs ccs-right clearfix">
          <li><span>Tasks</span></li>
          <li><span>Metadata</span></li>
          <li><span>Counters</span></li>
        </ul>

        <ul class="ccs-tab_sections ccs-clear">
          <li>
            <div class="jt_mr_display">
              <dl class="jtv_graph">
                <dt>Maps:</dt>
                <dd>${comps.mr_graph_maps(job)}</dd>
                <dt>Reduces:</dt>
                <dd>${comps.mr_graph_reduces(job, right_border=True)}</dd>
              </dl>
            </div>
            <% 
            task_table_size = '100%'
            if failed_tasks:
              task_table_size = '49%' 
            %>
            %if failed_tasks:
            <div class="jt_task_list jt_failed_tasks ccs-inline" style="width: ${task_table_size};">
              <h3>
                <a class="ccs-right" href="${url('jobtracker.views.tasks', jobid=job.jobId)}?taskstate=failed">view failed tasks &raquo;</a>
                Failed Tasks
              </h3>
              <div class="jt_task_list_container">
                ${task_table(failed_tasks)}
              </div>
            </div>
            %endif
            <div class="jt_task_list jt_recent_tasks ccs-inline" style="width: ${task_table_size}">
              <h3>
                <a class="ccs-right" href="${url('jobtracker.views.tasks', jobid=job.jobId)}">view all tasks &raquo;</a>
                Recent Tasks
              </h3>
              <div class="jt_task_list_container">
                ${task_table(recent_tasks)}
              </div>
            </div>
            
          </li>
          <li>
            <table class="ccs-data_table jt_meta_table sortable" cellpadding="0" cellspacing="0">
              <thead>
                <th>Name</th>
                <th>Value</th>
              </thead>
              <tbody>
                <tr>
                  <td>id</td>
                  <td>${job.jobId}</td>
                </tr>
                <tr>
                  <td>User</td>
                  <td>${job.user}</td>
                </tr>
                <tr>
                  <td>Maps</td>
                  <td>${job.finishedMaps} of ${job.desiredMaps}</td>
                </tr>
                <tr>
                  <td>Reduces</td>
                  <td>${job.finishedReduces} of ${job.desiredReduces}</td>
                </tr>
                <tr>
                  <td>Started</td>
                  <td>${job.startTimeFormatted}</td>
                </tr>
                <tr>
                  <td>Ended</td>
                  <td>${job.finishTimeFormatted}</td>
                </tr>
                <tr>
                  <td>Duration</td>
                  <td>${job.duration}</td>
                </tr>
                <tr>
                  <td>Status</td>
                  <td>${job.status}</td>
                </tr>
                ${rows_for_conf_vars(job.conf_keys)}
              </tbody>
            </table>
            
          </li>
          <li>
            ${comps.job_counters(job.counters)}
          </li>
        </ul>
      </div>


    ${comps.footer()}
