<%
  from jobtracker.views import get_state_link
  from desktop import appmanager
%>
<%namespace name="comps" file="jobtracker_components.mako" />
<%def name="get_state(option, state)">
%   if option == state:
      selected="true"
%   endif
</%def>

    % if len(jobs) > 0:
      ${comps.header("Job Browser", toolbar=False)}
      <div id="job_browser_list" class="view">
        <h1 class="ccs-hidden">Jobs</h1>
        <div class="toolbar">
          <a href="/jobtracker/jobs/"><img src="/jobtracker/static/art/icon_large.png" class="jt_icon"/></a>
          <ul class="jt_filters">
            <form class="jt_filter_form submit_on_change" method="get" action="/jobtracker/jobs/">
              <li class="ccs-inline"><b>Filter Jobs:</b></li>
              <li class="ccs-inline">
                <select name="state">
                  <option value="all" ${get_state('all', state_filter)}>All states</option>
                  <option value="running" ${get_state('running', state_filter)}>running</option>
                  <option value="failed" ${get_state('failed', state_filter)}>failed</option>
                  <option value="completed" ${get_state('completed', state_filter)}>completed</option>
                </select>
              </li>
              <li class="ccs-inline">
                <input type="text" class="jt_filter overtext" name="user" title="filter on user" value="${user_filter}"/>
              </li>
              <li class="ccs-inline">
                <input type="text" class="jt_filter overtext" name="text" title="text filter" value="${text_filter}"/>
              </li>
            </form>
          </ul>
        </div>
    
    
        <table class="ccs-data_table sortable" cellpadding="0" cellspacing="0">
          <thead>
            <tr>
              <th>Name / Id</th>
              <th>Status</th>
              <th>User</th>
              <th>Maps/Reduces</th>
              <th>Queue</th>
              <th>Priority</th>
              <th>Duration</th>
              <th colspan="3">Date</th>
            </tr>
          </thead>

          <tbody>
            % for job in jobs:
            <tr>
              <td>${job.jobName}
                  <div class="jt_jobid">${job.jobId_short}</div>
              </td>
              <td><a href="${url('jobtracker.views.jobs')}?${get_state_link(request, 'state', job.status.lower())}"
                    title="Show only ${job.status.lower()} jobs"
                    class="frame_tip status_link ${job.status.lower()}">${job.status.lower()}</a></td>
              <td><a href="${url('jobtracker.views.jobs')}?${get_state_link(request, 'user', job.user.lower())}"
                    title="Show only ${job.user.lower()} jobs"
                    class="frame_tip user_link ${job.user.lower()}">${job.user}</a></td>
              <td class="jt_mrs">

                ${comps.mr_graph(job)}
              
              </td>
              <td>${job.queueName}</td>
              <td>${job.priority.lower()}</td>
              <td>${job.durationFormatted}</td>
              <td>${job.startTimeFormatted}</td>
              <td>
                % if job.status.lower() == 'running' or job.status.lower() == 'pending':
                  <a href="${url('jobtracker.views.kill_job', jobid=job.jobId)}" class="frame_tip jt_kill confirm_and_post" title="Kill this job">kill</a>
                % endif
              </td>
              <td><a href="${url('jobtracker.views.single_job', jobid=job.jobId)}" class="frame_tip jt_view jt_slide_right" title="View this job">view</a></td>
            </tr>
            % endfor
          </tbody>
        </table>
      % else:
        ${comps.header("Job Browser", toolbar=True)}
        <div class="jt-welcome">
          <h2>Welcome to the Job Browser</h2>
          <p>There aren't any jobs running. Let's fix that.</p>
          <a href="/jobsub/list/" target="JobSub" class='jt-jobdesigner-button'>Launch the Job Designer</a>
          % if "beeswax" in appmanager.DESKTOP_APPS:
            <a href="/beeswax/" target="Beeswax" class='jt-beeswax-button'>Launch Beeswax</a>
          % endif
        </div>
      % endif
      <div class="jt-show_trackers">
        <a href="/jobtracker/trackers">view all task trackers &raquo;</a>
      </div>
    ${comps.footer()}
