#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from django.conf.urls.defaults import patterns, url

urlpatterns = patterns('jobtracker.views',
  # "Default"
  url(r'^$','jobtracker'),
  url(r'^trackers$','trackers',name='trackers'),
  url(r'^trackers/(?P<trackerid>.+)$','single_tracker',name='single_tracker'),
  url(r'^jobs/$','jobs',name='jobs'),
  url(r'^dock_jobs/$','dock_jobs',name='dock_jobs'),
  url(r'^jobs/(?P<jobid>\w+)$','single_job',name='single_job'),
  url(r'^jobs/(?P<jobid>\w+)/counters$','job_counters',name='job_counters'),
  url(r'^jobs/(?P<jobid>\w+)/kill$','kill_job',name='kill_job'),
  url(r'^jobs/(?P<jobid>\w+)/setpriority$','set_job_priority',name='set_job_priority'),
  url(r'^jobs/(?P<jobid>\w+)/tasks$','tasks',name='tasks'),
  url(r'^jobs/(?P<jobid>\w+)/tasks/(?P<taskid>\w+)$','single_task',name='single_task'),
  url(r'^jobs/(?P<jobid>\w+)/tasks/(?P<taskid>\w+)/attempts/(?P<attemptid>\w+)$',
      'single_task_attempt',name='single_task_attempt'),
  url(r'^jobs/(?P<jobid>\w+)/tasks/(?P<taskid>\w+)/attempts/(?P<attemptid>\w+)/counters$',
      'task_attempt_counters',name='task_attempt_counters'),
  url(r'^jobs/(\w+)/tasks/(\w+)/attempts/(?P<attemptid>\w+)/kill$',
      'kill_task_attempt',name='kill_task_attempt'),
  url(r'^clusterstatus$', 'clusterstatus',name='clusterstatus'),
  url(r'^queues$', 'queues',name='queues'),
  url(r'^jobtracker$','jobtracker',name='jobtracker'),
)
