#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
"""
Configuration options for the reverse proxy application.
"""
import re

from desktop.lib.conf import Config

def list_of_compiled_res(list_of_strings):
  if isinstance(list_of_strings, str):
    list_of_strings = [ list_of_strings ]
  return list(re.compile(x) for x in list_of_strings)
    
WHITELIST = Config(
  key="whitelist",
  default="(localhost|127\.0\.0\.1):(50030|50070|50060|50075)",
  help="Comma-separated list of regular expressions, which match 'host:ip' of requested proxy target.",
  type=list_of_compiled_res)
