// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Flash Messaging (notifications) for Desktop
provides: [CCS.Desktop.FlashMessage]
requires: [/CCS.Desktop, core/Fx.Tween, core/Fx.Transitions]
script: CCS.Desktop.FlashMessage.js

...
*/
/*
	flashMessage - displays a "growl" message for the user to read and dismiss
	messages - (array of strings for several messages or a single string) messages to display to the user. can be html.
*/
CCS.Desktop.flashMessages = [];
CCS.Desktop.flashMessage = function(messages, duration){
	messages = $splat(messages);
	var b = 60; // offset for get satifaction 
	
	var growls = $$('.growl');
	if(growls.length){ // if growls already exist
		var bottom = growls[growls.length-1].getStyle('bottom').toInt();
		b = bottom + growls[growls.length-1].getSize().y + 12;
	}
	var cleanup = function(msg) {
		CCS.Desktop.flashMessages.erase(msg);
	};
	messages.each(function(msg){
		CCS.Desktop.flashMessages.push(msg);
		var msgEl = new Element('div',{
			'class': 'growl', 
			html: msg,
			tween: {
				onComplete: function(){
					this.element.destroy();
					cleanup(msg);
				},
				transition: 'back:in'
			},
			events: {
				dblclick: function(){
					cleanup(msg);
					this.destroy(); 
				}
			},
			styles: {
				right : 0,
				bottom: b
			}
		}).inject(this.options.append);
		coords = msgEl.getCoordinates();
		b += (coords.height + 8);
		(function(){ 
			msgEl.tween('right', -300);
		}).delay(duration || 4500);
	},CCS.Desktop);
};
CCS.Desktop.checkForFlashMessage = function(message) {
	return CCS.Desktop.flashMessages.contains(message);
};