// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Calls code with a user profile supplied.
provides: [CCS.User]
requires: [ccs-shared/CCS]
script: CCS.User.js

...
*/
(function(){
        // Lazily cached user profile data.
	var data = undefined;

	var outstandingRequest = undefined;
	CCS.User = {

		/**
		 * Call a callback on the user object. This is asynchronous
		 * because we may not be logged in yet, so this has to go
		 * and fetch the user profile from the server.
		 */
		withUser: function(callback) {
			if (data) {
				callback(data);
			} else {
				if (outstandingRequest) {
					outstandingRequest.addEvent('onSuccess', callback);
				} else {
					outstandingRequest = new Request.JSON({
						url: '/profile',
						onSuccess: function(user_data) {
							outstandingRequest = undefined;
							data = user_data;
							callback(data);
						}
					}).send();
				}
			}
		}
	};
})();
