<%!
  import datetime
  from django.template.defaultfilters import urlencode, escape, stringformat, date, filesizeformat, time
  from filebrowser.views import truncate
%>
<%
  path_enc = urlencode(path)
  dirname_enc = urlencode(view['dirname'])
%>
<html>
<head><title>${truncate(filename)} :: File Viewer</title></head>
<body>
  <div class="toolbar">
    <div class="fv-path">${truncate(path, 100)}</div>
    <div class="fv-controls">
       <div class="fv-status">Page <span class="fv-bold">${(view['offset']/view['length']) + 1} of ${(stats['size']/view['length']) + 1}</span>   Bytes <span class="fv-byteInfo">${view['offset']+1}-${view['end']+1}</span> of <span class="fv-bold">${stats['size']} </span> </div>
       <div class="fv-navigation">
    <%
        base_url = url('filebrowser.views.view', path=path_enc)
        if view['offset'] == 0:
            first = ""
            prev = ""
        else:
            first = "href='%s?offset=0&length=%d'" %(base_url, view['length']) 
            prev =  "href='%s?offset=%d&length=%d'" %(base_url, max(0, view['offset']-view['length']), view['length']) 
        if view['offset'] + view['length'] >= stats['size']:
            next = ""
            last = ""
        else:
            next = "href='%s?offset=%d&length=%d'" %(base_url, view['offset'] + view['length'], view['length']) 
            last =  "href='%s?offset=%d&length=%d'" %(base_url, stats['size']-(stats['size'] % view['length']), view['length']) 
    %>
          <a class="fv-firstBlock" ${first}>First Block</a>
          <a class="fv-prevBlock" ${prev}>Previous Block</a>
          <a class="fv-nextBlock" ${next}>Next Block</a>
          <a class="fv-lastBlock" ${last}>Last Block</a>
       </div>
  </div>
  <div class="fv-actions ccs-button_bar">
      % if view['mode'] == "binary":
        <a class="fv-viewText ccs-art_button" data-icon-styles="{'width': 16, 'height': 16}" href="${base_url}?offset=${view['offset']}&length=${view['length']}&mode=text">View As Text</a>
      % endif

      % if view['mode'] == "text":
        <a class="fv-viewBinary ccs-art_button" data-icon-styles="{'width': 16, 'height': 16}" href="${base_url}?offset=${view['offset']}&length=${view['length']}&mode=binary">View As Binary</a>
      % endif
% if editable:
  <a class="fv-editFile ccs-art_button" data-icon-styles="{'width': 16, 'height': 16}" href="${url('filebrowser.views.edit', path=path_enc)}" target="FileEditor">Edit This File</a>
% endif
     <a class="fv-download ccs-art_button" target="_blank" data-icon-styles="{'width': 16, 'height': 16}" href="${url('filebrowser.views.download', path=path_enc)}">Download</a>
     <a class="fv-viewLocation ccs-art_button" data-icon-styles="{'width': 16, 'height': 16}" href="${url('filebrowser.views.view', path=dirname_enc)}" target="FileBrowser">View File Location</a>
  </div> 
  </div>
  <div class="splitview resizable">
    <div class="left_col jframe_padded">
      <dl class="fv-fileInfo">
        <dt>Last Modified</dt>
        <dd>${date(datetime.datetime.fromtimestamp(stats['mtime']))} ${time(datetime.datetime.fromtimestamp(stats['mtime']))}</dd>
        <dt>User</dt>
        <dd>${stats['user']}<dd>
        <dt>Group</dt>
        <dd>${stats['group']}</dd>
        <dt>Size</dt>
        <dd>${stats['size']|filesizeformat}<dd>
        ## Could convert this to "rw-rw-r--" form.
        <dt>Mode</dt>
        <dd>${stringformat(stats['mode'], "o")}</dd>
        ## Could increase accuracy here depending on how long ago this was
      </dl>
      </p>


     
    </div>
    <div class="right_col">
    %if 'contents' in view:
      % if view['masked_binary_data']:
      <div class="fv-binaryWarning">Warning: some binary data has been masked out with '.'.</div>
      % endif
    % endif
      <div class="jframe_padded">
      % if 'contents' in view:
             <div><pre><code>${view['contents']|escape}</code></pre></div>
      % else:
        <table>
          % for offset, words, masked in view['xxd']:
            <tr>
              <td><tt>${stringformat(offset, "07x")}:&nbsp;</tt></td>
            <td>
              <tt>
                % for word in words:
                  % for byte in word:
                    ${stringformat(byte, "02x")}
                  % endfor
                % endfor
              </tt>
            </td>
            <td>
              <tt>
                &nbsp;&nbsp;${masked}
              </tt>
            </td>
            </tr>
          % endfor
        </table>
      % endif
      </div>
    </div>
  </div>
</body>
</html>

