#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from django.conf.urls.defaults import url, patterns

# TODO(philip): The names below should be converted to be "qualified", i.e.,
# should be made "filebrowser.ajax_view" instead of "ajax_view".

urlpatterns = patterns('',

  # Base view
  url(r'^$', 'django.views.generic.simple.redirect_to', { "url": "/filebrowser/view/" }),

  url(r'listdir(?P<path>/.*)', 'filebrowser.views.listdir', name='listdir'),
  url(r'display(?P<path>/.*)', 'filebrowser.views.display', name='display'),
  url(r'stat(?P<path>/.*)', 'filebrowser.views.stat', name='stat'),
  url(r'download(?P<path>/.*)', 'filebrowser.views.download', name='download'),
  url(r'status', 'filebrowser.views.status', name='status'),
  # Catch-all for viewing a file (display) or a directory (listdir)
  url(r'view(?P<path>/.*)', 'filebrowser.views.view', name='view'),
  url(r'chooser(?P<path>/.*)', 'filebrowser.views.chooser', name='view'),
  url(r'edit(?P<path>/.*)', 'filebrowser.views.edit', name='edit'),
  url(r'save', 'filebrowser.views.save_file'),

  # POST operations
  url(r'upload', 'filebrowser.views.upload', name='upload'),
  url(r'rename', 'filebrowser.views.rename', name='rename'),
  url(r'mkdir', 'filebrowser.views.mkdir', name='mkdir'),
  url(r'^move', 'filebrowser.views.move', name='move'),
  url(r'remove', 'filebrowser.views.remove', name='remove'),
  url(r'rmdir', 'filebrowser.views.rmdir', name='rmdir'),
  url(r'rmtree', 'filebrowser.views.rmtree', name='rmtree'),
  url(r'chmod', 'filebrowser.views.chmod', name='chmod'),
  url(r'chown', 'filebrowser.views.chown', name='chown'),

  url(r'templates/(?P<tmpl>.*)', 'filebrowser.views.return_template')

)
