<%namespace name="wrappers" file="header_footer.mako" />
<%
from userman.views import make_home_path
%>

${wrappers.head()}
    <div id="userman_userlist" class="view">
      <table class="ccs-data_table sortable" cellpadding="0" cellspacing="0">
        <thead>
          <tr>
            <th>Username</th>
            <th>First Name</th>
            <th>Last Name</th>
            <th>E-mail</th>
            <th colspan="2">Last Login</th>
          </tr>
        </head>
        <tbody>
        % for user in users:
          <tr>
            <td>${user.username}</td>
            <td>${user.first_name}</td>
            <td>${user.last_name}</td>
            <td>${user.email}</td>
            <td>
              <span class="ccs-hidden">
                ${int(user.last_login.strftime("%s"))}
              </span>
              ${user.last_login.strftime('%c')}
            </td>
            <td>
              <a title="Edit ${user.username}" class="edit frame_tip" href="${ url('userman.views.edit_user', username=user.username) }">Edit</a>
              <a title="Delete ${user.username}" class="delete frame_tip confirm_and_post" alt="Are you sure you want to delete ${user.username}?" href="${ url('userman.views.delete_user', username=user.username) }">Delete</a>
              % if user.username in homedirs:
                <a title="${user.username}'s Home Directory" class="home frame_tip" target="FileBrowser" href="${ url('filebrowser.views.view', path=make_home_path(user.username)) }">Home</a>
              % else:
                <a title="Create ${user.username}'s Home Directory" alt="Create ${user.username}'s Home Directory?" class="create_home ccs-art_button frame_tip confirm_and_post" href="${ url('userman.views.create_home', username=user.username) }" data-icon-styles="{'width': 16, 'height': 16, 'top': 2}">Create Home</a>
              % endif
            </td>
          </tr>
        % endfor
        </tbody>
      </table>
      <a class="userman_add_user" href="${ url('userman.views.edit_user') }">Add User</a>
    </div>
${wrappers.foot()}