#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from desktop.lib.windmill_util import logged_in_client, logout

def test_user_creation():
  client = logged_in_client()

  # launch userman
  client.click(id='ccs-userman-menu')
  client.waits.forElement(jquery='(".userman")[0]', timeout='2000')

  # click add user and add "windmill_joe" user
  client.click(jquery="('.userman_add_user')[0]")
  client.type(text='windmill_joe', id='id_username')
  client.type(text='windmill', id='id_password1')
  client.type(text='windmill', id='id_password2')
  client.click(value='Save')
  # verify user is in list
  client.waits.forElement(classname='userman_userlist', timeout='2000')
  client.asserts.assertTextIn(classname='userman_userlist', validator='windmill_joe')

  # log in as windmill_joe
  logout(client)

  client = logged_in_client(user='windmill_joe', passwd='windmill')
  logout(client)

  client = logged_in_client()

  # launch userman
  client.click(id='ccs-userman-menu')
  client.waits.forElement(jquery='(".userman")[0]', timeout='2000')

  # delete the user
  client.click(jquery="('tr:contains(windmill_joe) .delete:last')[0]")
  client.click(jquery="('.userman .closeWin')[1]")

  # verify user is NOT in list
  client.waits.forElement(classname='userman_userlist', timeout='2000')
  client.asserts.assertNotTextIn(classname='userman_userlist', validator='windmill_joe')
