#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from nose.tools import assert_true, assert_false, assert_equal

from django.test import TestCase
from django.test.client import Client

class LoginTests(TestCase):
  def test_login(self):
    c = Client()
  
    response = c.get('/accounts/login_form')
    assert_equal(200, response.status_code, "Expected ok status.")
    assert_true(response.context['first_login_ever'])
  
    response = c.post('/accounts/login_ajax',
                      dict(username="foo",
                           password="foo"))
    assert_equal(200, response.status_code, "Expected ok status.")
  
    response = c.get('/accounts/login_form')
    assert_equal(200, response.status_code, "Expected ok status.")
    assert_false(response.context['first_login_ever'])
