#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc
# Copyright (c) 2010, Cloudera, inc. All rights reserved.

from django.forms import util
from django.forms import fields
from django import forms
import simplejson

class JsonFormField(fields.CharField):
  """
  Django field for validation JSON data.

  Note that this is a form field that defines validation routines,
  not a Model Field.
  
  See http://docs.djangoproject.com/en/1.0/ref/forms/validation/ for details.

  The Hampi DataFlowForm class has example usage.
  """

  widget = forms.Textarea

  default_error_messages = {
    'malformed_json': u'Unable to validate JSON'
    }
  
  def clean(self, value):
    value = super(JsonFormField, self).clean(value)
    try:
      simplejson.loads(value)
    except ValueError, e:
      raise util.ValidationError(e)
    return value
  