# Tests for ThriftField.
# Some parts based on http://www.djangosnippets.org/snippets/1044/
# Copyright (c) 2010, Cloudera, inc. All rights reserved.

import os
import sys
sys.path.insert(1, os.path.join(os.path.dirname(__file__), "gen-py"))
from djangothrift_test_gen.ttypes import TestStruct
import unittest

from django_test_util import configure_django_for_test, create_tables

configure_django_for_test()

from django.db import models
from djangothrift import ThriftField

class ThriftTestModel(models.Model):
  class Meta:
    app_label = "TEST_THRIFT_APP"

  my_int = models.IntegerField()
  my_struct = ThriftField(TestStruct)

class TestThriftField(unittest.TestCase):
  def test_store_and_retrieve(self):
    create_tables(ThriftTestModel)
    struct = TestStruct()
    struct.a = "hello world"
    struct.b = 12345
    x = ThriftTestModel()
    x.my_int = 3
    x.my_struct = struct
    x.save()

    y = ThriftTestModel.objects.all()[0]
    self.assertEqual(x.my_int, y.my_int)
    self.assertEqual(x.my_struct, y.my_struct)
    y.delete()

if __name__ == '__main__':
  unittest.main()
