#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

from windmill.authoring import WindmillTestClient
import windmill
import time

def logged_in_client(user='test', passwd='test', client=None):
  """
  Opens up the root URL.  If user is not logged in, logs him in.
  """
  if client is None:
    client = WindmillTestClient(__name__)
  client.open(url=windmill.settings['TEST_URL'] + '?clearSession=true')
  client.waits.forPageLoad()
  if client.execJS(js="$('ccs-login')")["output"] is not None:
    client.waits.forElement(classname='ccs-username')
    client.click(jquery='(".ccs-username")[0]')
    client.type(classname='ccs-username', text=user)
    client.click(classname='ccs-password')
    client.type(classname='ccs-password', text=passwd)
    client.click(classname='ccs-continue')
  # Health dashboard launches at login; ideally we'd have a 
  # better "ready" notification.
  time.sleep(2.0) # TODO: Hacky sleep!
  client.waits.forElement(classname='loggedIn', timeout='20000')
  return client

def logout(client):
  """
    logs the user out of desktop
  """
  client.click(jquery='("#ccs-logout a")[0]')
  # TODO(philip,nutron): Occasional bug.
  # We've seen the login box never show up.  This doesn't
  # trigger test failures, because we open the first page
  # at every test, but ideally we should assert that the login
  # box appears again.
  # client.waits.forElement(timeout='2000', classname='ccs-username')
