#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.

import logging
import sys
import traceback

LOG = logging.getLogger(__name__)

def entry():
  from django.core.management import execute_manager, find_commands, find_management_module
  from django.core.management import LaxOptionParser
  from django.core.management.base import BaseCommand
  try:
    from desktop import settings, appmanager
  except ImportError, ie:
    traceback.print_exc()
    sys.exit(1)

  # What's the subcommand being run?
  # This code uses the same logic from django.core.management to handle command args
  argv = sys.argv[:]
  parser = LaxOptionParser(option_list=BaseCommand.option_list)
  parser.parse_args(argv)
  if len(argv) > 1:
    subcommand = argv[1]

    # See if this command belongs to a disabled app
    commands = { }
    skipped_apps = sum([ app.django_apps for app in appmanager.SKIPPED_APPS ], [])
    for app_name in skipped_apps:
      try:
        path = find_management_module(app_name)
        if subcommand in find_commands(path):
          LOG.info("NOT starting the command '%s' from the disabled application '%s'. Exit." %
                   (subcommand, app_name))
          sys.exit(0)
      except ImportError:
        pass # No management module - ignore this app

  # Let django handle the normal execution
  execute_manager(settings)
