# Copyright (c) 2010, Cloudera, inc. All rights reserved.
import os

from django.core.management.base import NoArgsCommand

from desktop.lib.paths import get_build_dir
from hadoop.fs import fs_for_testing

class Command(NoArgsCommand):
  """Creates file system for testing."""
  def handle_noargs(self, **options):
    fs_dir = os.path.join(get_build_dir(), "fs")
    if not os.path.isdir(fs_dir):
      os.makedirs(fs_dir)
    fs_for_testing.create(fs_dir)
    print "Created fs in: %s" % fs_dir