#!/usr/bin/env python
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
#
# Tests for Desktop-specific middleware

from desktop.lib.django_test_util import make_logged_in_client

from nose.tools import assert_equal

def test_jframe_middleware():
  c = make_logged_in_client()
  path = "/about/?foo=bar&baz=3"
  response = c.get(path)
  assert_equal(path, response["X-Cloudera-JFrame-Path"])

  path_nocache = "/about/?noCache=blabla&foo=bar&baz=3"
  response = c.get(path_nocache)
  assert_equal(path, response["X-Cloudera-JFrame-Path"])

  path_nocache = "/about/?noCache=blabla&foo=bar&noCache=twiceover&baz=3"
  response = c.get(path_nocache)
  assert_equal(path, response["X-Cloudera-JFrame-Path"])

  path = "/about/"
  response = c.get(path)
  assert_equal(path, response["X-Cloudera-JFrame-Path"])

  response = c.get("/about/?")
  assert_equal("/about/", response["X-Cloudera-JFrame-Path"])
