<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
	<title>Cloudera Desktop</title>
	<!-- Test browser version first so we know it executes -->
	<script type="text/javascript">var $UA = navigator.userAgent; if(!$UA.match(/^mozilla/i) || !$UA.match(/\).*\/3\./) && (!$UA.match(/AppleWebKit/))) alert("Cloudera Desktop has only been extensively tested in Firefox 3.");</script>
	
	<link rel="shortcut icon" href="/UI/static/art/favicon.ico" type="image/x-icon" /> 
	<link rel="icon" href="/UI/static/art/favicon.ico" type="image/x-icon" />
	<link rel="stylesheet" href="/static/css/shared.css" type="text/css" media="screen" title="no title" charset="utf-8">
	<link rel="stylesheet" href="/UI/static/css/reset.css" type="text/css" media="screen" charset="utf-8">
	<link rel="stylesheet" href="/UI/static/css/windows.css" type="text/css" media="screen" charset="utf-8">
	<link rel="stylesheet" href="/UI/static/css/desktop.css" type="text/css" media="screen" charset="utf-8">

	<script src="/depender/build?client=true&require=dbug"></script>
	<script>
	(function(){
		var appName = "Desktop";

		Depender.require({
			scripts: ["CCS.Request", "CCS.User", "CCS.Desktop", "CCS.Desktop.Config", "CCS.Desktop.FlashMessage", "CCS.Desktop.Keys", "CCS.Login", "StickyWin.PointyTip", "Element.Delegation"],
			callback: function(){

				Clientcide.setAssetLocation("/static/js/ThirdParty/clientcide/Assets");
				var launchGrowl = function(component){
					var appName = CCS.Desktop.getAppName(component);
					var loading = 'Loading ' + appName;
					var launching = 'Launching ' + appName;
					var msg = loading;
					if (CCS.Desktop.hasLoaded(component)) msg = launching;
					if (!CCS.Desktop.checkForFlashMessage(loading) && 
							!CCS.Desktop.checkForFlashMessage(launching) && 
							!$$('.loadingmsg').length) {
								CCS.Desktop.flashMessage(msg);
					}
				};
				CCS.Desktop.initialize({
					onBeforeLoad: launchGrowl,
					onBeforeLaunch: launchGrowl
				});
				new Element('script', {
					src: '/bootstrap.js',
					events: {
						load: function(){

							(function(){
								$('ccs-loading').fade('out').get('tween').clearChain().chain(function(){
									$('ccs-loading').destroy();
								});
							}).delay(300);

							//when the user logs in
							CCS.User.withUser(function(user){
								//if there's no desktop to restore
								if (!CCS.Desktop.restoreDesktop()) {
									//call the autolaunchers
									CCS.Desktop.autolaunchers.each(function(fn){
										fn();
									});
									//and show the help docs if necessary
									new Request.JSON({
										url: "/accounts/login_count",
										onComplete: function(response) {
											if (response <= 3) {
												CCS.Desktop.launch('DocViewer');
											}
										}
									}).send();
								}

								$('ccs-profileLink').set('text', user.username).addClass('loggedIn');
								window.scrollTo(0,0);
								$('ccs-toolbar').show().tween('opacity', 0, 1);
								$('ccs-dock').tween('opacity', 0, 1);

							}.bind(this));
						}
					}
				}).inject(document.head);
			}
		});
		
		
		
	})();
	</script>
</head>
<body>
	
	<div id="ccs-desktop" class="ccs-shared">
		<div id="ccs-topnav">
			<div id="ccs-toolbar">
				<img src="/UI/static/art/toolbar-swoosh.png" width="13" height="22" alt="Toolbar Swoosh" class="ccs-swoosh">
				<span>
					Hi
					<span id="ccs-profileLink"></span>

					<span id="ccs-logout">
						[<a href="/accounts/logout">logout</a>]
					</span>
				</span>
				<a id="hotkeys" title="show keyboard shortcuts">
					<img src="/UI/static/art/shortcut.png"> Shortcuts
				</a>
			</div>
		</div>
		<div id="ccs-dock">
			<div id="ccs-dock-content">
				<div id="ccs-dock-status" class="ccs-inline">
					<div id="ccs-dock-status-content">
					</div>
				</div>
				<span id="ccs-dock-icons">
				</span>
			</div>
		</div>
		<div id="ccs-loading">Launching Cloudera Desktop</div>
		<a id="ccs-feedback" href="${feedback_url}" target="_blank"><img src="/UI/static/art/feedback-tab.png" width="76" height="26"/></a>
	</div>

		<script>
			if (Browser.Engine.trident) $(document.body).addClass('IEroot');
		</script>
</body>
</html>
