// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Handles the basic functionality of submitting a form and recieving JSON as a result.
provides: [Form.Request.JSON]
requires: [core/Request.JSON, More/Form.Request]
script: Form.Request.JSON.js

...
*/
Form.Request.JSON = new Class({

	Extends: Form.Request,

	initialize: function(form, options){
		this.parent(form, form, options);
	},

	makeRequest: function(){
		this.request = new Request.JSON($merge({
				url: this.element.get('action'),
				emulation: false,
				spinnerTarget: this.element,
				method: this.element.get('method') || 'post'
		}, this.options.requestOptions)).addEvents({
			success: function(obj, text){
				['success', 'complete'].each(function(evt){
					this.fireEvent(evt, [obj, text]);
				}, this);
			}.bind(this),
			failure: function(xhr){
				this.fireEvent('failure', xhr);
			}.bind(this),
			exception: function(){
				this.fireEvent('failure', xhr);
			}.bind(this)
		});
	}

});
