// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: An auto refresh filter for Jframe keyed on the meta-refresh tag.
provides: [CCS.JFrame.AutoRefresh]
requires: [/CCS.JFrame]
script: CCS.JFrame.AutoRefresh.js

...
*/

CCS.JFrame.addGlobalFilters({

	autorefresh: function(container, content){
		//get the first input.autorefresh and use its value as the duration before 
		//it auto refreshes the input. if span.sec_to_autorefresh is present, fill its
		//contents with the number of seconds until a refresh.
		if (content && content.meta) {
			var sec;
			content.meta.each(function(meta) {
				if (meta.get('http-equiv')) sec = meta.get('content').split(';')[0].toInt();
			}, this);
			if (!sec) return;
			var span = container.getElement('span.sec_to_autorefresh');
			var update = function() {
				if (span) span.set('html', sec);
				sec = sec - 1;
			}.bind(this);

			var timer = (function(){
				if (sec == 0) this.refresh();
				update(sec);
			}).periodical(1000, this);

			this.markForCleanup(function(){
				$clear(timer);
			});
		}
	}

});