// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Instantiates a Collapsible class for all matched elements with .collapser and .collapsible css classes.
provides: [CCS.JFrame.Collapsible]
requires: [/CCS.JFrame, clientcide/Collapsible]
script: CCS.JFrame.Collapsible.js

...
*/

CCS.JFrame.addGlobalFilters({

	collapsible: function(container) {
		//make collapsibles for each .collapser/.collapsible pair (kind of like accordion)
		var togglers = container.getElements('.collapser');
		var sections = container.getElements('.collapsible');
		togglers.each(function(toggler, i) {
			new Collapsible(toggler, sections[i], {
				onComplete: function(){
					if (this.hidden) {
						toggler.set('html', toggler.get('html').replace('Hide', 'Show'));
					} else {
						toggler.set('html', toggler.get('html').replace('Show', 'Hide'));
						if (window.OverText) OverText.update();
					}
				}
			});
		});
	}

});