// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Adds context menu support for any element with a data-context-menu-actions property. See the CCS.ContextMenu class for details on usage.
provides: [CCS.JFrame.ContextMenu]
requires: [/CCS.JFrame, /CCS.ContextMenu]
script: CCS.JFrame.ContextMenu.js

...
*/

CCS.JFrame.addGlobalFilters({

	//intercept right click behaviors
	contextMenu: function(container){
		//get the elements that capture right click events for context menus
		var delegates = container.getElements('[data-context-menu-actions]');
		if (!delegates.length) return;
		//create an instance of CCS.Context menu for each delegate
		var menus = delegates.map(function(delegate) {
			return new CCS.ContextMenu(delegate);
		});
		//detatch these whenever we unload jframe
		this.markForCleanup(function(){
			menus.each(function(menu){
				menu.detach();
			});
		});
	}

});