// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Creates an instance of Form.Request for every form that JFrame loads.
provides: [CCS.JFrame.FormRequest]
requires: [/CCS.JFrame, More/Form.Request]
script: CCS.JFrame.FormRequest.js

...
*/

CCS.JFrame.addGlobalFilters({

	formRequest: function(container){
		// Make forms submit inside the jframe
		container.getElements('form').each(function(form){
			form.set('action', new URI(form.get('action'), {base: this.currentPath}));
			//pass null for the update element argument; JFrame does our updating for us
			var req = new Form.Request(form, null, {
				//we don't want submission of the form to reset it on AJAX success;
				//sometimes JFrame gets an error back in the html; JFrame will replace
				//the form for us.
				resetForm: false
			});
			this._setRequestOptions(req.request, {
				onSuccess: function(nodes, elements, text){
					this._requestSuccessHandler(req.request, text);
				}.bind(this)
			});
		}, this);
	}

});
