// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: If any element loaded by JFrame has the css class .no_overflow, the jframe wrapper is set to have an overflow value of 'none'.
provides: [CCS.JFrame.NoOverflow]
requires: [/CCS.JFrame]
script: CCS.JFrame.NoOverflow.js

...
*/


CCS.JFrame.addGlobalFilters({

	noOverflow: function(container){
		//if the container has the class no_overflow, or an element within it has the no_overflow class
		//set the content to have no overflow; you must handle the overflow in your own css/js
		if (container.hasClass('no_overflow') || container.getElement('.no_overflow')) {
			this.element.setStyle('overflow', 'hidden');
		}
	}

});