// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Sets up all inputs with the css class .overtext to have an OverText instance for inline labeling.
provides: [CCS.JFrame.OverText]
requires: [/CCS.JFrame, More/OverText]
script: CCS.JFrame.OverText.js

...
*/

CCS.JFrame.addGlobalFilters({

	overText: function(container){
		//get all input.overtext elements and make an OverText for them.
		var ots = container.getElements('input.overtext, textarea.overtext').map(function(input){
			return new OverText(input);
		});
		var updater = function(){
			ots.each(function(ot) {
				ot.reposition();
			});
		};
		this.addEvent('loadComplete', updater);
		this.markForCleanup(function(){
			this.removeEvent('loadComplete', updater);
		}.bind(this));
	}

});