// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Makes any form with the css class .submit_on_change submit itself whenever any input is changed.
provides: [CCS.JFrame.SubmitOnChange]
requires: [/CCS.JFrame]
script: CCS.JFrame.SubmitOnChange.js

...
*/


CCS.JFrame.addGlobalFilters({

	submitOnChange: function(container) {
		container.getElements('form.submit_on_change').each(function(form) {
			form.getElements('input, select, textarea').each(function(input){
				input.addEvents({
					change: function(e){
						form.fireEvent('submit', e);
					},
					keydown: function(e) {
						if (e.key == 'enter') form.fireEvent('submit', e);
					}
				});
			});
		});
	}

});