// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Adds a tab interface (TabSwapper instance) for elements with .css-tab_ui. Matched with tab elements that are .ccs-tabs and sections that are .ccs-tab_sections.
provides: [CCS.JFrame.Tabs]
requires: [/CCS.JFrame, clientcide/TabSwapper]
script: CCS.JFrame.Tabs.js

...
*/

CCS.JFrame.addGlobalFilters({

	tabs: function(container) {
		if (!container.get('html').test('ccs-tab_ui')) return;
		var tabs = container.getElements('.ccs-tab_ui');
		var tabgroups = container.getElements('.ccs-tabs');
		var sections = container.getElements('.ccs-tab_sections');
		if (tabgroups.length != sections.length) {
			dbug.warn('warning; tab groups and sections are not of equal number. tabs: %o, sections: %o', tabgroups, sections);
			return;
		}
		tabgroups.each(function(tabgroup, tabIndex) {
			var ts = new TabSwapper({
				tabs: tabgroup.getChildren('li'),
				sections: sections[tabIndex].getChildren('li'),
				smooth: true,
				smoothSize: true
			});
			tabgroup.store('TabSwapper', ts);
		});
	}

});
