//Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Opens a CCS.FileChooser for any element with the ccs-choose_file class and places the path of the chosen file in the input field whose "name" attribute is equal to the data stored in  the "chooseFor" attribute of the element.
provides: [CCS.JFrame.Chooser]
requires: [/CCS.JFrame, filebrowser/CCS.FileChooser]
script: CCS.JFrame.Chooser.js

...
*/

CCS.JFrame.addGlobalLinkers({

	'.ccs-choose_file': function(e, link){
		//Stop link from its standard action
		e.preventDefault();
		var targetName = link.get('data','chooseFor');
		var targetInput = $(this.parentWidget).getElement('input[name=' + targetName + ']');
		var jbrowser = this.parentWidget;
		//use parent widget to get jbrowser for CCS.chooseFile
		//CCS.chooseFile creates an ART alert which contains a FileChooser from which teh user can select a file.

		//The function argument is the callback which is called after the OK button in the ART alert is clicked.
		CCS.Desktop.load("FileBrowser", function(){
			CCS.chooseFile(jbrowser, '/', "Choose a File", function(data) {
				targetInput.set('value', data.path);
				//hide overtext on targetInput 
				var overtext = targetInput.retrieve('OverText');
				if(overtext) overtext.hide();
			}, {
				filter: 'file'
			});
		});
	}

});
