// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Makes all links with the css class .confirm_and_post prompt the user and then send the link url as a post if they confirm.
provides: [CCS.JFrame.ConfirmAndPost]
requires: [/CCS.JFrame, art-widgets/ART.Alerts]
script: CCS.JFrame.ConfirmAndPost.js

...
*/

CCS.JFrame.addGlobalLinkers({

	'.confirm_and_post': function(e, link){
		//for each link with the class .confirm_and_post, confirm with the user and then post the url
		//use the link's title for the caption of the popup, and the alt as the body, 
		//defaulting to "Confirm" and "Are you sure?" respectively.
		if (e) e.preventDefault();
		
		var win = this.getWindow();
		var confirmer;
		if (win) confirmer = win.confirm.bind(win);
		else confirmer = ART.confirm;
		confirmer(link.get('title') || link.retrieve('tip:title') || 'Confirm', link.get('alt') || "Are you sure?", function(){
			this.load({
				requestPath: link.get('href').split('?')[0],
				data: new URI(link.get('href')).get('data'),
				method: 'post'
			});
		}.bind(this));
	}

});