// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: Makes all links with the css class .prompt_and_post prompt the user with the contents of the url in the link and then send the values they input when they hit ok.
provides: [CCS.JFrame.PromptAndPost]
requires: [/CCS.JFrame, art-widgets/ART.Alerts]
script: CCS.JFrame.PromptAndPost.js

...
*/

CCS.JFrame.addGlobalLinkers({

	'.prompt_and_post': function(e, link){
		//for each link with the class .prompt_and_post, prompt the user to fill out a form in a popup
		//with the contents of the link's href, applying delegates to the popup, and handling the 
		//form submission with a Form.Request.
		if (e) e.preventDefault();
		var target = new Element('div', {'class': 'jframe_prompt'});
		this.load({
			target: target,
			suppressLoadComplete: true,
			requestPath: link.get('href'),
			callback: function(data){
				var size = this.content.getSize();
				this.prompt(data.title || 'Enter Details', target, function(){
					target.getElement('form').retrieve('form.request').send();
				}, {
					resizable: true
				});
			}.bind(this)
		});
	}

});