/*
---
description: Takes any link with a target specified and, if that target matches an app name, launches that app with the link's url as the argument, otherwise it opens a new window/tab with that url.
provides: [CCS.JFrame.Target]
requires: [/CCS.JFrame]
script: CCS.JFrame.Target.js

...
*/
// Copyright (c) 2010, Cloudera, inc. All rights reserved.
CCS.JFrame.addGlobalLinkers({

	//any link with a target value launches the app named as the target if there is one
	//else opens new browser window/tab
	'a[target]': function(event, link) {
		var target = link.get('target');
		if (target != "_blank" && CCS.Desktop.hasApp(target)) CCS.Desktop.launch(target, link.get('href'));
		else window.open(link.get('href'), target);
	}

});