/*
---
description: Any JFrame response wthat has a root-level child element with the class .prompt_popup is displayed in a prompt overlaying the previous state which is restored when the prompt is canceled.
provides: [CCS.JFrame.Prompt]
requires: [/CCS.JFrame, art-widgets/ART.Alerts]
script: CCS.JFrame.Prompt.js

...
*/
// Copyright (c) 2010, Cloudera, inc. All rights reserved.
CCS.JFrame.addGlobalRenderers({

	prompt: function(content) {
		//if the contents have an element with .prompt_popup *at the root*
		//then display those contents in a prompt, submitting the form (if present)
		//when the user clicks "ok"
		var popup = content.elements.filter('.prompt_popup')[0];
		if (!popup) return;

		var target = new Element('div', {'class': 'jframe_prompt'});
		this._fill(target, content);
		var toolbar = target.getElements('.toolbar');
		if (toolbar.length) toolbar.hide();

		var size = this.content.getSize();
		var form = target.getElement('form');
		var prompt = this.prompt(content.title || 'Enter Details', target, function(){
			if (form) form.retrieve('form.request').send();
		}, {
			resizable: true
		});
		if (form) {
			form.addEvent('submit', function(){
				prompt.hide();
			});
			var inputs = form.getElements('input, textarea');
			var focused;
			inputs.some(function(input){
				if (focused) return;
				if (input.isVisible()) {
					focused = true;
					input.select();
				}
			});

		}
		return true;
	}

});