// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: StickyWin.UI.Solid
provides: [StickyWin.UI.Solid]
requires: [clientcide/StickyWin.UI, core/Class.Extras]
script: StickyWin.UI.Solid.js

...
*/
StickyWin.UI.Solid = new Class({

	Extends: StickyWin.UI,
	
	options: {
		width: 300,
		cssId: 'defaultSolidWinStyle',
		cssClassName: 'solid-win'
	},

	initialize: function(){

		var args = this.getArgs(arguments);
		this.setOptions(args.options);
		this.build();
		this.setContent(args.body);
	},

	build: function(){
		var opt = this.options;
		
		var container = new Element('div', {
			'class': opt.cssClassName,
			styles: {
				width: opt.width + 20
			}
		});
		this.element = container;
		this.element.store('StickyWinUI', this);

		this.body = new Element('div', {
			'class':'body',
			styles: {
				width: opt.width
			}
		});


		//body
		container.adopt(new Element('div').addClass('body-left').adopt(this.body));

		//footer
		container.adopt(
			new Element('div').addClass('bottom').adopt(
					new Element('div', {
						'class':'bottom_lr',
						styles: {
							width: opt.width
						}
					})
			)
		);
		return this;

	},

	setContent: function(content) {
		if ($(content)) this.body.empty().adopt(content);
		else this.body.set('html', content);
		return this;
	}

});
