// Copyright (c) 2010, Cloudera, inc. All rights reserved.
/*
---
description: ThumbTack
provides: [ThumbTack]
requires: [More/Fx.Move, More/Class.Occlude, More/Class.Binds]
script: ThumbTack.js

...
*/
var ThumbTack = new Class({

	Implements: [Options, Class.Occlude],
	
	Binds: ['position'],
	
	property: 'thumbTack',
	
	options: {
	//	destination: {},
	//	fxOptions: {},
		events: ['resize']
	},
	
	initialize: function(element, options) {
		this.element = $(element);
		if (this.occlude()) return this.occluded;
		this.setOptions(options);
		this.element.set('move', this.options.fxOptions);
		this.attach();
	},

	attach: function(detach){
		this.options.events.each(function(event) {
			window[detach ? 'removeEvent' : 'addEvent'](event, this.position);
		}, this);
		return this;
	},

	detach: function(){
		if (this.element) this.element.get('move').cancel();
		return this.attach(true);
	},

	position: function(destination){
		if (!this.element) return this.detach();
		this.element.move(destination || this.options.destination);
		return this;
	}

});
