#
# (c) Copyright 2010 Cloudera, Inc. All rights reserved.
#
# Packaging-related targets, included into toplevel makefile

srcdeb: $(BLD_DIR_PROD_TGZ)
	@echo "--- Making src debian package"
	@rm -rf $(BLD_DIR_SRCDEB)
	@mkdir -p $(BLD_DIR_SRCDEB)
	@cp $(BLD_DIR_PROD_TGZ) $(BLD_DIR_SRCDEB)/../cloudera-desktop_$(VERSION).orig.tar.gz
	@tar -C $(BLD_DIR_SRCDEB)/.. -zxf $(BLD_DIR_PROD_TGZ)
	@cp -a $(DEB_SCRIPTS) $(BLD_DIR_SRCDEB)
	@cd $(BLD_DIR_SRCDEB) && dpkg-buildpackage -uc -us -S
	@mkdir -p $(BLD_DIR_PKGS)
	@ln -sf $(BLD_DIR_SRCDEB)/../{*dsc,*.gz,*changes} $(BLD_DIR_PKGS)
	@echo "--- Debian src package at $(BLD_DIR_PKGS)"

$(HOME)/.rpmmacros:
	echo "%_topdir            $(HOME)/rpmbuild" > $(HOME)/.rpmmacros
	echo "%_builddir          %{_topdir}/BUILD" >> $(HOME)/.rpmmacros
	echo "%_rpmdir            %{_topdir}/RPMS" >> $(HOME)/.rpmmacros
	echo "%_sourcedir         %{_topdir}/SOURCES" >> $(HOME)/.rpmmacros
	echo "%_specdir           %{_topdir}/SPECS" >> $(HOME)/.rpmmacros
	echo "%_srcrpmdir         %{_topdir}/SRPMS" >> $(HOME)/.rpmmacros
	echo "%_buildrootdir      %{_topdir}/BUILDROOT" >> $(HOME)/.rpmmacros

srpm: prod
	@echo "--- Making srpm package"
	@rm -Rf $(BLD_DIR_RPM_ROOT) $(BLD_DIR_RPM_TODIR)
	@mkdir -p $(BLD_DIR_RPM_ROOT) $(BLD_DIR_RPM_TODIR) $(BLD_DIR_PKGS)
	@cd $(BLD_DIR_RPM_TODIR) && mkdir BUILD RPMS SOURCES SPECS SRPMS
	@cp $(BLD_DIR_PROD_TGZ) $(RPM_SCRIPTS)/cloudera-desktop.init $(BLD_DIR_RPM_TODIR)/SOURCES
	@rpmbuild --nodeps --define "_topdir $(BLD_DIR_RPM_TODIR)" \
	  --buildroot $(BLD_DIR_RPM_ROOT) -bs $(RPM_SCRIPTS)/cloudera-desktop.spec
	@find $(BLD_DIR_RPM_TODIR) -name '*.rpm' -exec ln -sf '{}' $(BLD_DIR_PKGS) \;
